/*
xstradd: concatenate arbitrary number of C strings
Copyright (C) 2000 Ed Cashin

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#include	<stdio.h>
#include	<stdlib.h>
#include	"xstradd.h"
#include	"xtextadd.h"
#ifdef	LEAK_DETECTION
#include	"leakfind.h"
#endif

#define	TEST_TIMES	15000

int main(int argc, char *argv[])
{
    char	*shortstr      = "foobar";
    char	*teststr;
    int		i;
    char *(*addfunc)(const char *s, ...);

    if (argc > 1) {
      puts("using xtextadd");
      addfunc	 = xtextadd;
    } else {
      puts("using xstradd");
      addfunc	 = xstradd;
    }

    for (i = 0; i < TEST_TIMES; ++i) {
      teststr    = addfunc("foo", "bar", " ",
			   "barnaby", " ",
			   "whomba", "!", " ", " ",
			   shortstr,
			   NULL);
      free(teststr);
    }

#ifdef	LEAK_DETECTION
    GC_gcollect();
#endif
    return 0;
}

